/* read mp3 header & tag, author: hackbard */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <errno.h>

#define ID_TAG_SIZE 128
#define MAX_BUF_SIZE 32
#define MAX_TITLE 30
#define MAX_ARTIST 30
#define MAX_ALBUM 30
#define MAX_YEAR 4
#define MAX_COMMENT 30
#define MAX_GENRE 1

#define MAX_FILENAME 32


/*
info:
http://www.dv.co.yu/mpgscript/mpeghdr.htm
*/

int main (int argc,char **argv)
{
 int file_fd;
 int file_size;
 unsigned char buf[MAX_BUF_SIZE];
 char filename[MAX_FILENAME];

 strcpy(filename,argv[1]);
 file_size=atoi(argv[2]);

 if((file_fd=open(filename,O_RDONLY))<=0) {
  puts("open failed");
  return -23;
 }

 if((lseek(file_fd,file_size-ID_TAG_SIZE,SEEK_SET))<0) {
  puts("cannot seek to id tag");
  return -23;
 }

 /* verify TAG now */
 if((read(file_fd,&buf,3))<3) {
  puts("read failed (1)");
  return -23;
 }

 if(strncmp(buf,"TAG",3)) {
  puts("TAG not found");
  return -23;
 }

 read(file_fd,&buf,MAX_TITLE);
 printf("title: %s\n",buf);

 read(file_fd,&buf,MAX_ARTIST);
 printf("artist: %s\n",buf);

 read(file_fd,&buf,MAX_ALBUM);
 printf("album: %s\n",buf);

 read(file_fd,&buf,MAX_YEAR);
 printf("year: %s\n",buf);

 read(file_fd,&buf,MAX_COMMENT);
 printf("comment: %s\n",buf);

 read(file_fd,&buf,MAX_GENRE);
 printf("genre: %c\n",*buf);

 close(file_fd);
 
 return 23;
}
